<template lang="pug">


	#control(:style="estilo")

		svg(
			ref="control"
			:width="ancho",
			:height="alto",
			:viewBox="`-${margen} -${margen} ${ancho} ${alto}`"
			xmlns:xlink="http://www.w3.org/1999/xlink",
			xmlns="http://www.w3.org/2000/svg",
			preserveAspectRatio="xMidYMid slice",
		)
			rect.area(
				ref="area",
				:x="0",
				:y="0",
				:width="pagina.ancho",
				:height="pagina.alto"
				@mousedown="areaMouseDown",
				@mousemove="mouseMove",
				@mouseup="arrastrando = false",
			)
			//- @click="areaClick",
			g.seleccion(
				v-if="seleccion"
				:transform="`translate(${seleccion.x}, ${seleccion.y})`"
				ref="seleccion"
				)
				//- g(v-if="modo=='editor'")
				rect.esquina.no(
					v-if="(modo=='editor') || permisos.redimensionable"
					:x="-margen",
					:y="-margen",
					:width="margen",
					:height="margen")
				rect.barra.n(
					v-if="(modo=='editor') || permisos.redimensionable"
					:x="0",
					:y="-margen",
					:width="seleccion.width",
					:height="margen")
				rect.esquina.ne(
					v-if="(modo=='editor') || permisos.redimensionable"
					:x="seleccion.width",
					:y="-margen",
					:width="margen",
					:height="margen")
				rect.barra.o(
					v-if="(modo=='editor') || permisos.redimensionable"
					:x="-margen",
					:y="0",
					:width="margen",
					:height="seleccion.height")
				rect.esquina.so(
					v-if="(modo=='editor') || permisos.redimensionable"
					:x="-margen",
					:y="seleccion.height",
					:width="margen",
					:height="margen")
				rect.esquina.se(
					v-if="(modo=='editor') || permisos.redimensionable"
					:x="seleccion.width",
					:y="seleccion.height",
					:width="margen",
					:height="margen",
					@mousedown="seMouseDown",
					@mousemove="mouseMove",
					@mouseup="mouseUp",
					)
				rect.barra.e(
					v-if="(modo=='editor') || permisos.redimensionable"
					:x="seleccion.width",
					:y="0",
					:width="margen",
					:height="seleccion.height"
					@mousedown="eMouseDown",
					@mousemove="mouseMove",
					@mouseup="mouseUp",
					)
				rect.barra.s(
					v-if="(modo=='editor') || permisos.redimensionable"
					:x="0",
					:y="seleccion.height",
					:width="seleccion.width",
					:height="margen / zoom"
					@mousedown="sMouseDown",
					@mousemove="mouseMove",
					@mouseup="mouseUp",
					)
				rect.centro(
					:class="{movible:(modo=='editor') || permisos.movible}"
					ref="centro"
					:x="0",
					:y="0",
					:width="seleccion.width",
					:height="seleccion.height",
					@click="centroClick",
					@mousedown="centroMouseDown",
					@mousemove="mouseMove",
					@mouseup="mouseUp",
				)
				//- rect.o(:x="seleccion.width", :y="seleccion.height", :width="margen", :height="margen")
		//- Component(is="p") {{opt}}
		//- Component(is="img", src="https://www.tetonas.me/wp-content/uploads/2019/02/Abella-Danger-2.jpg")
		pre.
		//- {{seleccion}}
		//- {{ancho}}
</template>

<script>
import { mapState, mapGetters, mapMutations, mapActions } from 'vuex'

export default {
	data(){
		return{
			arrastrando: null,
			referencia: {
					x: 0,
					y: 0
			},
			inicio: {
					x: 0,
					y: 0
			}
		}
	},
	computed: {
		estilo(){
			return {
				width: `${this.ancho}px`,
				height: `${this.alto}px`,
				transform: `scale(${this.zoom})`
			}
		},
		...mapState({
			opciones: "opciones",
			margen: state => state.opciones.margen,
			seleccion: state => state.editor.seleccion,
			modo: state => state.editor.modo,
			zoom: state => state.editor.zoom,

		}),
		...mapGetters({
			pagina : "contenido/actual",

			ancho : "editor/ancho",
			alto : "editor/alto",
			permisos: "contenido/permisos"
			// seleccion: "editor/seleccion",
		})
	},
	methods:{
		areaClick(evt){},
		areaMouseDown(evt){
			const CTM = this.$refs.area.getScreenCTM()
			// console.debug("click")
			// console.debug(evt.clientX, evt.clientY)
			// console.debug(evt.offsetX, evt.offsetY)
			// console.debug(Math.floor((evt.clientX - CTM.e) / CTM.a), Math.floor((evt.clientY - CTM.f) / CTM.d))

			this.$emit('control:seleccion', {x:evt.clientX, y:evt.clientY})
		},
		centroClick(evt){
			evt.cancelBubble = true
		},
		centroMouseDown(evt){
			this.$emit('control:seleccion', {x:evt.clientX, y:evt.clientY})
			if (this.modo == "editor" || this.permisos.movible) {
				this.arrastrando = "centro"
				const CTM = this.$refs.area.getScreenCTM()
				this.inicio.x = ((evt.clientX - CTM.e) / CTM.a) - this.seleccion.x;
				this.inicio.y = ((evt.clientY - CTM.f) / CTM.d) - this.seleccion.y;
			}
			// console.debug("centroMouseDown")
			// console.debug(CTM)
			// console.debug(this.ratonDesplazamiento.x,this.ratonDesplazamiento.y)
			// console.debug(evt.clientX, evt.clientY)
			// console.debug(CTM.e, CTM.a, CTM.f, CTM.d)
		},
		seMouseDown(evt){
			this.arrastrando = "se"
			// const CTM = this.$refs.control.getScreenCTM()

			this.inicio = {
				x: this.seleccion.x,
				y: this.seleccion.y
			}
		},
		eMouseDown(evt){
			this.arrastrando = "e"
			this.inicio = {
				x: this.seleccion.x,
				y: this.seleccion.y
			}
		},
		sMouseDown(evt){
			this.arrastrando = "s"
			this.inicio = {
				x: this.seleccion.x,
				y: this.seleccion.y
			}
		},
		mouseMove(evt) {
			const CTM = this.$refs.area.getScreenCTM()
			let x, y, ancho, alto
			switch (this.arrastrando){
				case "centro":
					x = Math.floor((evt.clientX - CTM.e) / CTM.a) - this.inicio.x
					y = Math.floor((evt.clientY - CTM.f) / CTM.d) - this.inicio.y
					this.moverElemento({x, y})
					break
				case "se":
					// const controlCTM = this.$refs.control.getScreenCTM()
					ancho = Math.floor((evt.clientX - CTM.e) / CTM.a) - this.inicio.x
					alto = Math.floor((evt.clientY - CTM.f) / CTM.d) - this.inicio.y
					// console.log(ancho, alto)
					this.redimensionarElemento({ancho, alto})
					break
				case "e":
					// const controlCTM = this.$refs.control.getScreenCTM()
					ancho = Math.floor((evt.clientX - CTM.e) / CTM.a) - this.inicio.x
					// const alto = ((evt.clientY - CTM.f) / CTM.d) - this.inicio.y
					// console.log(ancho, alto)
					this.redimensionarElemento({ancho})
					break
				case "s":
					// const controlCTM = this.$refs.control.getScreenCTM()
					// ancho = ((evt.clientX - CTM.e) / CTM.a) - this.inicio.x
					alto = Math.floor((evt.clientY - CTM.f) / CTM.d) - this.inicio.y
					// alto /= this.zoom
					// console.log(ancho, alto)
					this.redimensionarElemento({alto})
					break
			}
			// if (this.arrastrando=="centro") {
			// 	// console.debug(evt)
			// 	evt.preventDefault()
			// 	const CTM = this.$refs.area.getScreenCTM()
			// 	const x = ((evt.clientX - CTM.e) / CTM.a) - this.inicio.x
			// 	const y = ((evt.clientY - CTM.f) / CTM.d) - this.inicio.y
				// const x = evt.clientX
				// const y = evt.clientY
				// console.log(x, y)


				// this.$refs.control.setAttributeNS(null, "x", x);
				// this.$refs.control.setAttributeNS(null, "y", y);

		},
		mouseUp(evt) {
			this.arrastrando = false
			this.actualizarPrevio()
		},
		...mapMutations({
			moverSelecccion: "editor/moverSeleccion",
			modificarSeleccion: "editor/modificarSeleccion",
			// moverElemento: "editor/moverElemento",
			// modificarSeleccion: "editor/modificarSeleccion",
		}),
		...mapActions({
				moverElemento: "editor/moverElemento",
				redimensionarElemento: "editor/redimensionarElemento",
				actualizarPrevio: "editor/actualizarPrevio",
		})
	}
}
</script>

<style lang="stylus" scoped>
#control
	margin 0 auto
	padding 0
	overflow visible
	user-select none
	box-sizing content-box
	transition all 150ms ease-in-out

	// > *
		// outline 1px solid red

	svg
		background-color transparent
		transition all 150ms ease-in-out

	.esquina
		fill navy

	.barra
		fill transparent

	.centro
		fill rgba(0,0,0,0.1)
		stroke-dasharray 5, 5
		stroke-width 2
		stroke navy

		&.movible
			cursor move

	.area
		fill transparent
		fill rgba(0,0,0,0)

	.no
		cursor nw-resize

	.n
		cursor n-resize

	.ne
		cursor ne-resize

	.e
		cursor e-resize

	.so
		cursor sw-resize

	.s
		cursor s-resize

	.se
		cursor se-resize

	.o
		cursor w-resize


pre
	width 90%
</style>
